

--首页内容核心数据
SELECT partition_date as `日期`
	  ,nvl(round(ios_ym_new_click_uv/ios_ym_new_sy_uv,2),0) as `iOS医美新用户首页卡片点击uv/ios医美新用户首页uv`
	  ,nvl(round(ios_ym_new_good_click/ios_ym_new_card_click_uv,2),0) as `iOS医美新用户good click 卡片数uv/iOS医美新用户首页点击卡片数uv`
	  ,nvl(round(ios_ym_old_click_uv/ios_ym_old_sy_uv,2),0) as `iOS医美老用户首页卡片点击uv/iOS医美老用户首页uv`
	  ,nvl(round(ios_ym_old_good_click/ios_ym_old_card_click_uv,2),0) as `iOS医美老用户good click 卡片数uv/iOS医美老用户首页点击卡片数uv`

	  ,nvl(round(ios_ai_new_click_uv/ios_ai_new_sy_uv,2),0) as `iOS AI新用户首页卡片点击uv/iOS AI新用户首页uv`
	  ,nvl(round(ios_ai_new_good_click/ios_ai_new_card_click_uv,2),0) as `iOS AI新用户good click 卡片数uv/iOS AI新用户首页点击卡片数uv`
	  ,nvl(round(ios_ai_old_click_uv/ios_ai_old_sy_uv,2),0) as `iOS AI老用户首页卡片点击uv/iOS AI老用户首页uv`
	  ,nvl(round(ios_ai_old_good_click/ios_ai_old_card_click_uv,2),0) as `iOS AI老用户good click 卡片数uv/iOS AI老用户首页点击卡片数uv`

	  ,nvl(round(andr_ai_new_click_uv/andr_ai_new_sy_uv,2),0) as `AI安卓新用户首页卡片点击uv/AI安卓新用户首页uv`
	  ,nvl(round(andr_ai_new_good_click/andr_ai_new_card_click_uv,2),0) as `AI安卓新用户信息流good click 卡片数uv/AI安卓新用户首页点击卡片数uv`
	  ,nvl(round(andr_ai_old_click_uv/andr_ai_old_sy_uv,2),0) as `AI安卓老用户首页卡片点击uv/AI安卓老用户首页uv`
	  ,nvl(round(andr_ai_old_good_click/andr_ai_old_card_click_uv,2),0) as `AI安卓老用户信息流good click 卡片数uv/AI安卓老用户首页点击卡片数uv`

	  ,nvl(round(andr_ym_new_click_uv/andr_ym_new_sy_uv,2),0) as `安卓医美新用户首页卡片点击uv/安卓医美新用户首页uv`
	  ,nvl(round(andr_ym_new_good_click/andr_ym_new_card_click_uv,2),0) as `安卓医美新用户信息流good click 卡片数uv/安卓医美新用户首页点击卡片数uv`
	  ,nvl(round(andr_ym_old_click_uv/andr_ym_old_sy_uv,2),0) as `安卓医美老用户首页卡片点击uv/安卓医美老用户首页uv`
	  ,nvl(round(andr_ym_old_good_click/andr_ym_old_card_click_uv,2),0) as `安卓医美老用户信息流good click 卡片数uv/安卓医美老用户首页点击卡片数uv`

FROM
(
	SELECT t1.partition_date
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='新增' then t4.device_id end) as ios_ym_new_click_uv		--iOS医美新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='新增' then t3.device_id end) as ios_ym_new_sy_uv 		--ios医美新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='新增' then array(t5.cl_id,t5.business_id) end) as ios_ym_new_good_click 	--iOS医美新用户good click
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='新增' then t4.device_id end) as ios_ym_new_card_click_uv		--iOS医美新用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='老活' then t4.device_id end) as ios_ym_old_click_uv		--iOS医美老用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='老活' then t3.device_id end) as ios_ym_old_sy_uv 		--ios医美老用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='老活' then array(t5.cl_id,t5.business_id) end) as ios_ym_old_good_click 	--iOS医美老用户good click
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='医美' and t1.device_type='老活' then t4.device_id end) as ios_ym_old_card_click_uv		--iOS医美老用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='新增' then t4.device_id end) as ios_ai_new_click_uv		--iOSAI新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='新增' then t3.device_id end) as ios_ai_new_sy_uv 		--iosAI新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='新增' then array(t5.cl_id,t5.business_id) end) as ios_ai_new_good_click 	--iOSAI新用户good click
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='新增' then t4.device_id end) as ios_ai_new_card_click_uv		--iOSAI新用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='老活' then t4.device_id end) as ios_ai_old_click_uv		--iOSAI老用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='老活' then t3.device_id end) as ios_ai_old_sy_uv 		--iosAI老用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='老活' then array(t5.cl_id,t5.business_id) end) as ios_ai_old_good_click 	--iOSAI老用户good click
		  ,count(distinct case when t1.device_os_type='ios' and t1.channel='AI' and t1.device_type='老活' then t4.device_id end) as ios_ai_old_card_click_uv		--iOSAI老用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='新增' then t4.device_id end) as andr_ai_new_click_uv		--androidAI新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='新增' then t3.device_id end) as andr_ai_new_sy_uv 		--androidAI新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='新增' then array(t5.cl_id,t5.business_id) end) as andr_ai_new_good_click 	--androidAI新用户good click
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='新增' then t4.device_id end) as andr_ai_new_card_click_uv		--androidAI新用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='老活' then t4.device_id end) as andr_ai_old_click_uv		--androidAI新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='老活' then t3.device_id end) as andr_ai_old_sy_uv 		--androidAI新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='老活' then array(t5.cl_id,t5.business_id) end) as andr_ai_old_good_click 	--androidAI新用户good click
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='AI' and t1.device_type='老活' then t4.device_id end) as andr_ai_old_card_click_uv		--androidAI新用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='新增' then t4.device_id end) as andr_ym_new_click_uv		--androidAI新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='新增' then t3.device_id end) as andr_ym_new_sy_uv 		--androidAI新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='新增' then array(t5.cl_id,t5.business_id) end) as andr_ym_new_good_click 	--androidAI新用户good click
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='新增' then t4.device_id end) as andr_ym_new_card_click_uv		--androidAI新用户首页卡片数点击uv

		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='老活' then t4.device_id end) as andr_ym_old_click_uv		--androidAI新用户首页卡片点击uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='老活' then t3.device_id end) as andr_ym_old_sy_uv 		--androidAI新用户首页浏览uv
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='老活' then array(t5.cl_id,t5.business_id) end) as andr_ym_old_good_click 	--androidAI新用户good click
		  ,count(distinct case when t1.device_os_type='android' and t1.channel='医美' and t1.device_type='老活' then t4.device_id end) as andr_ym_old_card_click_uv		--androidAI新用户首页卡片数点击uv

	FROM
	(	--分渠道，新老
		SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
		          ,device_os_type,device_id
		          ,CASE WHEN active_type = '4' THEN '老活'  when active_type in ('1','2') then '新增' END as device_type
		          ,CASE WHEN is_ai_channel = 'true' THEN 'AI' ELSE '医美' END  as channel
	    FROM online.ml_device_day_active_status
	    LEFT JOIN
		        (SELECT code,is_ai_channel,partition_day
		         FROM DIM.DIM_AI_CHANNEL_ZP_NEW
		         WHERE partition_day>= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		         AND partition_day <= regexp_replace(DATE_SUB(current_date,1) ,'-','')) tmp
		    ON  partition_date=tmp.partition_day AND first_channel_source_type=code
	    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
	    and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
	    AND active_type IN ('1','2','4')
	    AND first_channel_source_type not IN ('yqxiu1','yqxiu2','yqxiu3','yqxiu4','yqxiu5','mxyc1','mxyc2','mxyc3'
	            ,'wanpu','jinshan','jx','maimai','zhuoyi','huatian','suopingjingling','mocha','mizhe','meika','lamabang'
	            ,'js-az1','js-az2','js-az3','js-az4','js-az5','jfq-az1','jfq-az2','jfq-az3','jfq-az4','jfq-az5','toufang1'
	            ,'toufang2','toufang3','toufang4','toufang5','toufang6','TF-toufang1','TF-toufang2','TF-toufang3','TF-toufang4'
	            ,'TF-toufang5','tf-toufang1','tf-toufang2','tf-toufang3','tf-toufang4','tf-toufang5','benzhan','promotion_aso100'
	            ,'promotion_qianka','promotion_xiaoyu','promotion_dianru','promotion_malioaso','promotion_malioaso-shequ'
	            ,'promotion_shike','promotion_julang_jl03','promotion_zuimei','','unknown')
	    AND first_channel_source_type not LIKE 'promotion\_jf\_%'
	)t1

	LEFT JOIN
	(	--去除黑名单
	    select distinct device_id
	    from ML.ML_D_CT_DV_DEVICECLEAN_DIMEN_D
	    where PARTITION_DAY =regexp_replace(DATE_SUB(current_date,1) ,'-','')
	    AND is_abnormal_device = 'true'
	)t2
	on t1.device_id=t2.device_id

	LEFT JOIN
	(	--首页浏览
		SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
			  ,cl_id as device_id
		FROM online.bl_hdfs_maidian_updates
		where partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		and partition_date<=regexp_replace(DATE_SUB(current_date,1) ,'-','')
		AND action = 'page_view'
		AND page_name='home'
		group by concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)),cl_id,params['card_id']
	)t3
	on t3.partition_date=t1.partition_date and t3.device_id=t1.device_id

	LEFT JOIN
	(	--首页feed卡片点击
		SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
			  ,cl_id as device_id
			  ,params['card_id'] as card_id
			  ,count(distinct array(params['card_id'],app_session_id)) as click_pv
		FROM online.bl_hdfs_maidian_updates
		where partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		and partition_date<=regexp_replace(DATE_SUB(current_date,1) ,'-','')
		and action='on_click_card'
		and page_name='home'
		and params['card_type'] in ('card','video','search_word')
		group by partition_date
			   ,cl_id
			   ,params['card_id']

		UNION ALL

		--点击埋点有丢失，用浏览事件补充一下
		SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
			  ,cl_id as device_id
			  ,params['business_id'] as card_id
			  ,count(distinct array(params['card_id'],app_session_id)) as click_pv
		FROM online.bl_hdfs_maidian_updates
		where partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		and partition_date<=regexp_replace(DATE_SUB(current_date,1) ,'-','')
		and action='page_view'
		and (referrer in ('home') or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('home')))
		and (page_name in ('diary_detail','topic_detail','post_detail','user_post_detail','doctor_post_detail','question_detail','answer_detail','question_answer_detail',
		                    'video_steep','article_detail') or page_name like 'search_result_%')
		group by partition_date
			   ,cl_id
			   ,params['business_id']
	)t4
	on t3.partition_date=t4.partition_date and t3.device_id=t4.device_id

	LEFT JOIN
	(	--内容的good click代码
		select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date
			,a.cl_id,a.business_id
		from
		(
			select *,case when page_name in ('diary_detail','topic_detail') THEN 'diary'
						  when page_name in ('post_detail','user_post_detail','doctor_post_detail') THEN 'post'
						  when page_name in ('answer_detail') THEN 'answer' end content_type
			FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
			WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
			and (referrer='home' or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1]='home'))
			and (page_name in ('diary_detail','topic_detail','post_detail','user_post_detail','doctor_post_detail','question_detail','answer_detail','question_answer_detail',
		                          'video_steep','article_detail') or page_name like 'search_result_%')
            --and (params['is_push']=0 or params['is_push'] is null)
		)a
		left join
		(--评论的埋点有缺失，所以用业务库数据来补充
		    --日记这里取的是日记本id，因为从首页点击卡片进入后，先进入日记卡片
		    SELECT diary_id as content_id,'diary' as type,user_id,create_date
		    FROM
		    (
		        SELECT id,problem_id,user_id,regexp_replace(substr(reply_date,1,10),'-','') as create_date
		        FROM online.tl_hdfs_topicreply_view
		        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
		        AND is_spam = 'false'  --排除疑似广告
		        and is_online='true'
		        and regexp_replace(substr(reply_date,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		        group by id,problem_id,user_id,reply_date
		    )t1
		    JOIN
		    (
		        SELECT id,diary_id
		        FROM online.tl_hdfs_problem_view
		        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
		        group by id,diary_id
		    )t2
		    on t2.id=t1.problem_id
		    group by diary_id,user_id,create_date

		    UNION ALL

		    --有评论过回答的设备,排除疑似广告

		    SELECT answer_id as content_id,'answer' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
		    FROM online.tl_hdfs_answer_reply_view
		    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    and (is_fake is NULL or is_fake = 'false')
		    AND answer_id is not NULL
		    and is_online='true'
		    and is_spam = 'false'  --排除疑似广告
		    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    group by answer_id,user_id,create_time

		    UNION ALL

		    --有评论过用户帖的设备
		    SELECT tractate_id as content_id,'post' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
		    FROM  online.tl_hdfs_api_tractate_reply_view
		    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    and is_online='true'
		    group by tractate_id,user_id,create_time
		)b
		on a.business_id=b.content_id and a.partition_date=b.create_date and a.user_id=b.user_id and a.content_type=b.type
		WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
				 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
				 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
				 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
				 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
				 or (action='on_click_favor' and params['motion']='do')--点击收藏
				 or action='page_click_share'--点击分享
				 or (action='on_click_vote' and params['motion']='vote')--点击点赞
				 or b.user_id is not null --当天有针对内容的评论
				 or page_name like 'search_result_%' and action not in ('upload_page','report_status','popup_view','refresh_page','on_app_session_over'))--在搜索结果页有点击行为
		group by a.partition_date,a.cl_id,a.business_id
	)t5
	on t4.partition_date=t5.partition_date and t4.device_id=t5.cl_id and t4.card_id=t5.business_id
	WHERE t2.device_id is null
	group by t1.partition_date
)t
order by `日期`;