
--搜索内容核心数据
SELECT t.partition_date as `日期`
	  ,nvl(round(old_diary_gc_uv/old_diary_click_uv,2),0) as `老用户在日记页卡good click 卡片数uv/日记页卡点击uv`
	  ,nvl(round(old_qa_gc_uv/old_qa_click_uv,2),0) as `老用户在问答页卡good click 卡片数uv/问答页卡点击uv`
	  ,'-' as `老用户在帖子页卡good click 卡片数uv/帖子页卡点击uv`
	  ,nvl(round(old_wiki_gc_uv/old_wiki_click_uv,2),0) as `老用户在百科页卡good click 卡片数uv/百科页卡点击uv`

	  ,nvl(round(ios_ym_new_diary_gc_uv/ios_ym_new_diary_click_uv,2),0) as `ios医美新在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  ,nvl(round(ios_ym_new_qa_gc_uv/ios_ym_new_qa_click_uv,2),0) as `ios医美新在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`
	  -- ,ios_ym_old_diary_gc_uv/ios_ym_old_diary_click_uv as `ios医美老在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  -- ,ios_ym_old_qa_gc_uv/ios_ym_old_qa_click_uv as `ios医美老在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`
	  ,'-' as `ios医美新在帖子页卡good click 卡片数uv/搜索帖子页结果页点击设备数uv`
	  ,nvl(round(ios_ym_new_wiki_gc_uv/ios_ym_new_wiki_click_uv,2),0) as `ios医美新在百科页卡good click 卡片数uv/搜索百科页结果页点击设备数uv`

	  ,nvl(round(andr_ym_new_diary_gc_uv/andr_ym_new_diary_click_uv,2),0) as `android医美新在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  ,nvl(round(andr_ym_new_qa_gc_uv/andr_ym_new_qa_click_uv,2),0) as `android医美新在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`
	  -- ,andr_ym_old_diary_gc_uv/andr_ym_old_diary_click_uv as `android医美老在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  -- ,andr_ym_old_qa_gc_uv/andr_ym_old_qa_click_uv as `android医美老在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`

	  ,nvl(round(ios_ai_new_diary_gc_uv/ios_ai_new_diary_click_uv,2),0) as `iosAI新在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  ,nvl(round(ios_ai_new_qa_gc_uv/ios_ai_new_qa_click_uv,2),0) as `iosAI新在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`
	  -- ,ios_ai_old_diary_gc_uv/ios_ai_old_diary_click_uv as `iosAI老在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  -- ,ios_ai_old_qa_gc_uv/ios_ai_old_qa_click_uv as `iosAI老在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`

	  ,nvl(round(andr_ai_new_diary_gc_uv/andr_ai_new_diary_click_uv,2),0) as `android AI新在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  ,nvl(round(andr_ai_new_qa_gc_uv/andr_ai_new_qa_click_uv,2),0) as `android AI新在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`
	  -- ,andr_ai_old_diary_gc_uv/andr_ai_old_diary_click_uv as `android AI老在日记页卡good click 卡片数uv/搜索日记页结果页点击设备数uv`
	  -- ,andr_ai_old_qa_gc_uv/andr_ai_old_qa_click_uv as `android AI老在问答页卡good click 卡片数uv/搜索问答页结果页点击设备数uv`


FROM
(
	SELECT t1.partition_date
		  ,count(case when device_type='老活' then t4.cl_id end) as old_diary_gc_uv
		  ,count(distinct case when device_type='老活' and diary_click_pv>0 then t3.cl_id end) as old_diary_click_uv
		  ,count(case when device_type='老活' then t5.cl_id end) as old_qa_gc_uv
		  ,count(distinct case when device_type='老活' and qa_click_pv>0 then t3.cl_id end) as old_qa_click_uv
		  ,count(case when device_type='老活' then t6.cl_id end) as old_post_gc_uv
		  ,count(distinct case when device_type='老活' and post_click_pv>0 then t3.cl_id end) as old_post_click_uv
		  ,count(case when device_type='老活' then t7.cl_id end) as old_wiki_gc_uv
		  ,count(distinct case when device_type='老活' and wiki_click_pv>0 then t3.cl_id end) as old_wiki_click_uv

		  ,count(case when device_os_type='ios' and channel='医美' and device_type='新增' then t4.cl_id end) as ios_ym_new_diary_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='新增' and diary_click_pv>0 then t3.cl_id end) as ios_ym_new_diary_click_uv
		  ,count(case when device_os_type='ios' and channel='医美' and device_type='新增' then t5.cl_id end) as ios_ym_new_qa_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='新增' and qa_click_pv>0 then t3.cl_id end) as ios_ym_new_qa_click_uv
		  ,count(case when device_os_type='ios' and channel='医美' and device_type='老活' then t4.cl_id end) as ios_ym_old_diary_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='老活' and diary_click_pv>0 then t3.cl_id end) as ios_ym_old_diary_click_uv
		  ,count(case when device_os_type='ios' and channel='医美' and device_type='老活' then t5.cl_id end) as ios_ym_old_qa_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='老活' and qa_click_pv>0 then t3.cl_id end) as ios_ym_old_qa_click_uv

		  ,count(case when device_os_type='android' and channel='医美' and device_type='新增' then t4.cl_id end) as andr_ym_new_diary_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='新增' and diary_click_pv>0 then t3.cl_id end) as andr_ym_new_diary_click_uv
		  ,count(case when device_os_type='android' and channel='医美' and device_type='新增' then t5.cl_id end) as andr_ym_new_qa_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='新增' and qa_click_pv>0 then t3.cl_id end) as andr_ym_new_qa_click_uv
		  ,count(case when device_os_type='android' and channel='医美' and device_type='老活' then t4.cl_id end) as andr_ym_old_diary_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='老活' and diary_click_pv>0 then t3.cl_id end) as andr_ym_old_diary_click_uv
		  ,count(case when device_os_type='android' and channel='医美' and device_type='老活' then t5.cl_id end) as andr_ym_old_qa_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='老活' and qa_click_pv>0 then t3.cl_id end) as andr_ym_old_qa_click_uv

		  ,count(case when device_os_type='ios' and channel='AI' and device_type='新增' then t4.cl_id end) as ios_ai_new_diary_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='新增' and diary_click_pv>0 then t3.cl_id end) as ios_ai_new_diary_click_uv
		  ,count(case when device_os_type='ios' and channel='AI' and device_type='新增' then t5.cl_id end) as ios_ai_new_qa_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='新增' and qa_click_pv>0 then t3.cl_id end) as ios_ai_new_qa_click_uv
		  ,count(case when device_os_type='ios' and channel='AI' and device_type='老活' then t4.cl_id end) as ios_ai_old_diary_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='老活' and diary_click_pv>0 then t3.cl_id end) as ios_ai_old_diary_click_uv
		  ,count(case when device_os_type='ios' and channel='AI' and device_type='老活' then t5.cl_id end) as ios_ai_old_qa_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='老活' and qa_click_pv>0 then t3.cl_id end) as ios_ai_old_qa_click_uv

		  ,count(case when device_os_type='android' and channel='AI' and device_type='新增' then t4.cl_id end) as andr_ai_new_diary_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='新增' and diary_click_pv>0 then t3.cl_id end) as andr_ai_new_diary_click_uv
		  ,count(case when device_os_type='android' and channel='AI' and device_type='新增' then t5.cl_id end) as andr_ai_new_qa_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='新增' and qa_click_pv>0 then t3.cl_id end) as andr_ai_new_qa_click_uv
		  ,count(case when device_os_type='android' and channel='AI' and device_type='老活' then t4.cl_id end) as andr_ai_old_diary_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='老活' and diary_click_pv>0 then t3.cl_id end) as andr_ai_old_diary_click_uv
		  ,count(case when device_os_type='android' and channel='AI' and device_type='老活' then t5.cl_id end) as andr_ai_old_qa_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='老活' and qa_click_pv>0 then t3.cl_id end) as andr_ai_old_qa_click_uv

		  ,count(case when device_os_type='ios' and channel='医美' and device_type='新增' then t6.cl_id end) as ios_ym_new_post_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='新增' and post_click_pv>0 then t3.cl_id end) as ios_ym_new_post_click_uv
		  ,count(case when device_os_type='ios' and channel='医美' and device_type='新增' then t7.cl_id end) as ios_ym_new_wiki_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='医美' and device_type='新增' and wiki_click_pv>0 then t3.cl_id end) as ios_ym_new_wiki_click_uv

		  ,count(case when device_os_type='ios' and channel='AI' and device_type='新增' then t6.cl_id end) as ios_ai_new_post_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='新增' and post_click_pv>0 then t3.cl_id end) as ios_ai_new_post_click_uv
		  ,count(case when device_os_type='ios' and channel='AI' and device_type='新增' then t7.cl_id end) as ios_ai_new_wiki_gc_uv
		  ,count(distinct case when device_os_type='ios' and channel='AI' and device_type='新增' and wiki_click_pv>0 then t3.cl_id end) as ios_ai_new_wiki_click_uv

		  ,count(case when device_os_type='android' and channel='医美' and device_type='新增' then t6.cl_id end) as andr_ym_new_post_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='新增' and post_click_pv>0 then t3.cl_id end) as andr_ym_new_post_click_uv
		  ,count(case when device_os_type='android' and channel='医美' and device_type='新增' then t7.cl_id end) as andr_ym_new_wiki_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='医美' and device_type='新增' and wiki_click_pv>0 then t3.cl_id end) as andr_ym_new_wiki_click_uv

		  ,count(case when device_os_type='android' and channel='AI' and device_type='新增' then t6.cl_id end) as andr_ai_new_post_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='新增' and post_click_pv>0 then t3.cl_id end) as andr_ai_new_post_click_uv
		  ,count(case when device_os_type='android' and channel='AI' and device_type='新增' then t7.cl_id end) as andr_ai_new_wiki_gc_uv
		  ,count(distinct case when device_os_type='android' and channel='AI' and device_type='新增' and wiki_click_pv>0 then t3.cl_id end) as andr_ai_new_wiki_click_uv



	FROM
	(	--分渠道，新老
		SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
		          ,device_os_type,device_id
		          ,CASE WHEN active_type = '4' THEN '老活'  when active_type in ('1','2') then '新增' END as device_type
		          ,CASE WHEN is_ai_channel = 'true' THEN 'AI' ELSE '医美' END  as channel
	    FROM online.ml_device_day_active_status
	    LEFT JOIN
		        (SELECT code,is_ai_channel,partition_day
		         FROM DIM.DIM_AI_CHANNEL_ZP_NEW
		         WHERE partition_day>= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		         AND partition_day <= regexp_replace(DATE_SUB(current_date,1) ,'-','')) tmp
		    ON  partition_date=tmp.partition_day AND first_channel_source_type=code
	    WHERE partition_date >=  REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
	    and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
	    AND active_type IN ('1','2','4')
	    AND first_channel_source_type not IN ('yqxiu1','yqxiu2','yqxiu3','yqxiu4','yqxiu5','mxyc1','mxyc2','mxyc3'
	            ,'wanpu','jinshan','jx','maimai','zhuoyi','huatian','suopingjingling','mocha','mizhe','meika','lamabang'
	            ,'js-az1','js-az2','js-az3','js-az4','js-az5','jfq-az1','jfq-az2','jfq-az3','jfq-az4','jfq-az5','toufang1'
	            ,'toufang2','toufang3','toufang4','toufang5','toufang6','TF-toufang1','TF-toufang2','TF-toufang3','TF-toufang4'
	            ,'TF-toufang5','tf-toufang1','tf-toufang2','tf-toufang3','tf-toufang4','tf-toufang5','benzhan','promotion_aso100'
	            ,'promotion_qianka','promotion_xiaoyu','promotion_dianru','promotion_malioaso','promotion_malioaso-shequ'
	            ,'promotion_shike','promotion_julang_jl03','promotion_zuimei','','unknown')
	    AND first_channel_source_type not LIKE 'promotion\_jf\_%'
	)t1

	LEFT JOIN
	(	--去除黑名单
	    select distinct device_id
	    from ML.ML_D_CT_DV_DEVICECLEAN_DIMEN_D
	    where PARTITION_DAY =regexp_replace(DATE_SUB(current_date,1) ,'-','')
	    AND is_abnormal_device = 'true'
	)t2
	on t2.device_id=t1.device_id

	LEFT JOIN
	(	--搜索结果页卡片点击
		select partition_date,cl_id,card_id,content_type,sum(diary_click_pv) as diary_click_pv,sum(qa_click_pv) as qa_click_pv
			  ,sum(post_click_pv) as post_click_pv,sum(wiki_click_pv) as wiki_click_pv
		from
		(
		    SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id
		    	,case when action='on_click_diary_card' then params['diary_id'] else params['card_id'] end as card_id
		    	,case when page_name='search_result_diary' then 'diary'
		    		  when page_name='search_result_question_answer' then 'answer'
		    		  when page_name='search_result_post' then 'post'
		    		  when page_name='search_result_wiki' then 'wiki' end as content_type
		        ,count(distinct CASE WHEN page_name='search_result_diary' THEN array(params['card_id']) END) as diary_click_pv
		        ,count(distinct CASE WHEN page_name='search_result_question_answer' THEN array(params['card_id']) END) as qa_click_pv
		        ,count(distinct CASE WHEN page_name='search_result_post' THEN array(params['card_id']) END) as post_click_pv
		        ,count(distinct CASE WHEN page_name='search_result_wiki' THEN array(params['card_id']) END) as wiki_click_pv
		    FROM online.bl_hdfs_maidian_updates
		    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    AND partition_date <=regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    AND ((action = 'on_click_card' AND params['card_content_type'] in ('answer','diary','question','qa',
		    	'wiki_collect','wiki_item','wiki_brand','wiki_material','wiki_drug','wiki_instrument'))
		      or action in ('on_click_diary_card','on_click_topic_card','search_result_wiki_click_recommend_wiki'))
		    AND page_name in ('search_result_diary','search_result_question_answer','search_result_post' ,'search_result_wiki')
		    GROUP BY cl_id,partition_date,case when action='on_click_diary_card' then params['diary_id'] else params['card_id'] end
		    		,case when page_name='search_result_diary' then 'diary'
		    		  when page_name='search_result_question_answer' then 'answer'
		    		  when page_name='search_result_post' then 'post'
		    		  when page_name='search_result_wiki' then 'wiki' end

		    union all
		    --点击埋点有丢，所以用页面浏览来补充一下

		    SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id
		    	,params['business_id'] as card_id
		    	,case when page_name in ('diary_detail','post_detail','user_post_detail','doctor_post_detail')
		    	           and referrer='search_result_diary' then 'diary'
		    		  when page_name in ('question_detail','answer_detail','question_answer_detail') then 'answer'
		    		  when page_name in ('post_detail','user_post_detail','doctor_post_detail')
		    		  	   and referrer='search_result_post' then 'post'
		    		  when page_name in ('wiki_detail','wiki_collect','product_detail','wiki_brand') then 'wiki'
		    		  end as content_type
		        ,count(distinct CASE WHEN page_name in ('diary_detail','post_detail','user_post_detail','doctor_post_detail') and referrer='search_result_diary' THEN time_str END) as diary_click_pv
		        ,count(distinct CASE WHEN page_name in ('question_detail','answer_detail','question_answer_detail') THEN time_str end)as qa_click_pv
		        ,count(distinct CASE WHEN page_name in ('post_detail','user_post_detail','doctor_post_detail') and  referrer='search_result_post' THEN time_str END) as post_click_pv
		        ,count(distinct CASE WHEN page_name in ('wiki_detail','wiki_collect','product_detail','wiki_brand') THEN time_str end)as wiki_click_pv
		    FROM online.bl_hdfs_maidian_updates
		    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    AND partition_date <=regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    AND action='page_view'
		    AND referrer in ('search_result_diary','search_result_question_answer','search_result_post','search_result_wiki')
		    and page_name in ('diary_detail','topic_detail','post_detail','user_post_detail','doctor_post_detail','question_detail','answer_detail','question_answer_detail',
	                          'video_steep','article_detail','wiki_detail','wiki_collect','product_detail','wiki_brand')
		    GROUP BY cl_id,partition_date,params['business_id']
		    		,case when page_name in ('diary_detail','post_detail','user_post_detail','doctor_post_detail')
		    	           and referrer='search_result_diary' then 'diary'
		    		  when page_name in ('question_detail','answer_detail','question_answer_detail') then 'answer'
		    		  when page_name in ('post_detail','user_post_detail','doctor_post_detail')
		    		  	   and referrer='search_result_post' then 'post'
		    		  when page_name in ('wiki_detail','wiki_collect','product_detail','wiki_brand') then 'wiki' end
		)t
		group by partition_date,cl_id,card_id,content_type
	)t3
	on t3.partition_date=t1.partition_date and t3.cl_id=t1.device_id

	LEFT JOIN
	(	--日记内容的good click代码
		select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date
			,a.cl_id,a.business_id,'diary' as content_type
		from
		(
			select *,case when page_name in ('diary_detail','topic_detail') THEN 'diary'
						  when page_name in ('post_detail','user_post_detail','doctor_post_detail') THEN 'post'
						  end content_type
			FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
			WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
			and (referrer in ('search_result_diary') or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('search_result_diary')))
			and page_name in ('diary_detail','topic_detail','post_detail','user_post_detail','doctor_post_detail')
		)a
		left join
		(--评论的埋点有缺失，所以用业务库数据来补充
		    --日记这里取的是日记本id，因为从首页点击卡片进入后，先进入日记卡片
		    SELECT diary_id as content_id,'diary' as type,user_id,create_date
		    FROM
		    (
		        SELECT id,problem_id,user_id,regexp_replace(substr(reply_date,1,10),'-','') as create_date
		        FROM online.tl_hdfs_topicreply_view
		        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
		        AND is_spam = 'false'  --排除疑似广告
		        and is_online='true'
		        and regexp_replace(substr(reply_date,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		        group by id,problem_id,user_id,reply_date
		    )t1
		    JOIN
		    (
		        SELECT id,diary_id
		        FROM online.tl_hdfs_problem_view
		        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
		        group by id,diary_id
		    )t2
		    on t2.id=t1.problem_id
		    group by diary_id,user_id,create_date

		    UNION ALL

		    --有评论过用户帖的设备
		    SELECT tractate_id as content_id,'post' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
		    FROM  online.tl_hdfs_api_tractate_reply_view
		    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    and is_online='true'
		    group by tractate_id,user_id,create_time
		)b
		on a.business_id=b.content_id and a.partition_date=b.create_date and a.user_id=b.user_id and a.content_type=b.type
		WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
				 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
				 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
				 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
				 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
				 or (action='on_click_favor' and params['motion']='do')--点击收藏
				 or action='page_click_share'--点击分享
				 or (action='on_click_vote' and params['motion']='vote')--点击点赞
				 or b.user_id is not null )--当天有针对内容的评论
		group by a.partition_date,a.cl_id,a.business_id,a.content_type
	)t4
	on t4.partition_date=t3.partition_date and t4.cl_id=t3.cl_id and t4.business_id=t3.card_id and t4.content_type=t3.content_type

	LEFT JOIN
	(	--问答内容的good click代码
		select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date
			,a.cl_id,a.business_id,'answer' as content_type
		from
		(
			select *
			FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
			WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
			and (referrer in ('search_result_question_answer') or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('search_result_question_answer')))
			and page_name in ('question_detail','answer_detail','question_answer_detail')
		)a
		left join
		(--评论的埋点有缺失，所以用业务库数据来补充
		    --有评论过回答的设备,排除疑似广告

		    SELECT answer_id as content_id,'answer' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
		    FROM online.tl_hdfs_answer_reply_view
		    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    and (is_fake is NULL or is_fake = 'false')
		    AND answer_id is not NULL
		    and is_online='true'
		    and is_spam = 'false'  --排除疑似广告
		    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    group by answer_id,user_id,create_time

		)b
		on a.business_id=b.content_id and a.partition_date=b.create_date and a.user_id=b.user_id
		WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
				 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
				 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
				 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
				 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
				 or (action='on_click_favor' and params['motion']='do')--点击收藏
				 or action='page_click_share'--点击分享
				 or (action='on_click_vote' and params['motion']='vote')--点击点赞
				 or b.user_id is not null )--当天有针对内容的评论
		group by a.partition_date,a.cl_id,a.business_id
	)t5
	on t5.partition_date=t3.partition_date and t5.cl_id=t3.cl_id and t5.business_id=t3.card_id and t5.content_type=t3.content_type

	LEFT JOIN
	(	--帖子内容的good click
		select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date
			,a.cl_id,a.business_id,'post' as content_type
		from
		(
			select *,case when page_name in ('post_detail','user_post_detail','doctor_post_detail') THEN 'post'
						  end content_type
			FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
			WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
			and (referrer in ('search_result_post') or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('search_result_post')))
			and page_name in ('post_detail','user_post_detail','doctor_post_detail')
		)a
		left join
		(--评论的埋点有缺失，所以用业务库数据来补充
		    --有评论过用户帖的设备
		    SELECT tractate_id as content_id,'post' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
		    FROM  online.tl_hdfs_api_tractate_reply_view
		    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
		    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
		    and is_online='true'
		    group by tractate_id,user_id,create_time
		)b
		on a.business_id=b.content_id and a.partition_date=b.create_date and a.user_id=b.user_id and a.content_type=b.type
		WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
				 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
				 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
				 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
				 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
				 or (action='on_click_favor' and params['motion']='do')--点击收藏
				 or action='page_click_share'--点击分享
				 or (action='on_click_vote' and params['motion']='vote')--点击点赞
				 or b.user_id is not null )--当天有针对内容的评论
		group by a.partition_date,a.cl_id,a.business_id,a.content_type
	)t6
	on t6.partition_date=t3.partition_date and t6.cl_id=t3.cl_id and t6.business_id=t3.card_id and t6.content_type=t3.content_type

	LEFT JOIN
	(	--百科内容的good click
		select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date
			,a.cl_id,a.business_id,'wiki' as content_type
		from
		(
			select *,case when page_name in ('wiki_detail','wiki_collect','product_detail','wiki_brand') THEN 'wiki'
						  end content_type
			FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
			WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
			and (referrer in ('search_result_wiki') or
		          (params['referrer_link'] like '%[%' and
		           json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('search_result_wiki')))
			and page_name in ('wiki_detail','wiki_collect','product_detail','wiki_brand')
		)a
		WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
				 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
				 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
				 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
				 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
				 or (action='on_click_favor' and params['motion']='do')--点击收藏
				 or action='page_click_share'--点击分享
				 or (action='on_click_vote' and params['motion']='vote')--点击点赞
				 --or b.user_id is not null --当天有针对内容的评论
				 or (action='page_view' and page_name='select_compare') --百科开始对比页面浏览
				 )
	)t7
	on t7.partition_date=t3.partition_date and t7.cl_id=t3.cl_id and t7.business_id=t3.card_id and t7.content_type=t3.content_type
    WHERE t2.device_id is null
	group by t1.partition_date
)t
order by `日期`;
